Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 100%
Category: Estimated time: 0:00 hour

Target version:
Module: dcmdata, andere? Compiler:

Operating System:

Description
Status: erledigt? [JR]

DCMTK unterstutzt zur Zeit keine Dateien > 2 GByte. Unter Solaris gibt
es zwei Mdglichkeiten, wie man auf gréBere Dateien zugreifen kann (man
Ifcompile, man Ifcompile64), unter Linux scheinbar nur die erste Variante.

— Long File Support sollte wohl eine Configure-Option sein, default: an wenn
vorhanden (?)

- In Configure mit "getconf LFS_CFLAGS" die Compiler-Optionen herausfinden,
die flir "Long File Support" gesetzt werden miissen, dito

"getconf LFS_LDFLAGS" und "getconf LFS_LIBS"

— Auf jeden Fall muss fseeko() statt fseek(), ftello statt ftell verwendet
werden
— Eine Liste aller Systemfunktionen, die "betroffen" sind, findet man unter

Solaris mit "man 1f64". Flir jede dieser Funktionen muss gepriift werden, ob

DCMTK den "offiziellen" Datentyp verwendet, der ggf. 64-bittig definiert

ist. Das betrifft neben fseeko/ftello auch lockf, readdir, open, mmap,

get/setrlimit, fstat, lseek. Nutzung im Toolkit:

- fseek: dcmdata/apps/pdf2dcm.cc, dcmdata/apps/dcmftest.cc, dcmdata/libsrc/dcistrmf.cc,
dcmmisc/apps/pdf2dcm.cc, dcmmisc/apps/dcecmmkmg.cc, dcmmisc/apps/dcmmkmg.cc,
dcmsign/apps/dcmsign.cc

- ftell: dcmdata/libsrc/dcistrmf.cc, dcmmisc/apps/dcmmkmg.cc, dcmsign/apps/dcmsign.cc

— lockf (unused)

- readdir: ofstd/libsrc/ofstd.cc, dcmpstat/apps/dcmprscu.cc, dcmpps/libsrc/ppsmgram.cc,
dcmwlm/libsrc/wlfsim.cc

- open: dcmgrdb/libsrc/dcmgrcbg.cc, dcemgrdb/libsrc/dcecmgrcbm.cc, dcemgrdb/libsrc/dcemgrdbi
dcmgrdb/libsrc/demgrsrv.cc, dcmgrdb/libsrc/demgrtis.cc, dcmpstat/apps/dcmpsrcv
dcmpstat/apps/dcmpssnd.cc, dcmnet/apps/storescp.cc, dcmpps/libsrc/ppsmgram.cc,
dcmpps/libsrc/ppsfsim.cc, dcmwlm/libsrc/wldsfs.cc

- mmap (unused)

- get/setrlimit (unused)

- fstat (unused)

- lseek: dcmgrdb/libsrc/dcmgrdbi.cc, dcmnet/libsrc/dcompat.cc

- Insbesondere die Stream-Klassen in dcmdata verwenden derzeit explizit
Uint32, um die aktuelle Position im Stream zu beschreiben. Das muss geédndert
werden. Problematisch ist, dass es Uint64 vermutlich nicht auf Jjeder
Plattform gibt. Geschickter wdre es vielleicht, off_t usw. selbst zu
definieren falls nicht vorhanden.

- Aus der Linux-fseeko-Manpage:
On many architectures both off_t and long are 32-bit types, but compilation with
#define _FILE_OFFSET_BITS 64
will turn off_t into a 64-bit type.

- Ein anderes Makro in diesem Zusammenhang scheint __ USE_LARGEFILE64 zu sein,
dessen Bedeutung ist mir aber nicht ganz klar.

- Implementierungsstrategie:
sizeof (long) ==
off_t und fseeko existieren und sizeof (off_t)==8 (mit #define _FILE_OFFSET_BITS 64)

ob es off_t gibt (wenn ja, dann benutzen)
ob es fseeko/ftello gibt (wenn Jja, dann benutzen)
LFS_CFLAGS, LFS_LDFLAGS und LFS_LIBS ermitte

ob es getconf gibt, wenn ja,

ob es die lfcompile6b4-Funktionen gibt

wie man 1lf-Support bekommt:
8 —> nothing to do.

lfcompileb4 existiert -> lfcompile64 nutzen

-> 1f

History

#1 - 2013-09-12 21:55 - J6rg Riesmeier

- % Done changed from 0 to 50

#2 - 2013-09-14 19:06 - J6rg Riesmeier

- Status changed from New to Closed

- % Done changed from 50 to 100
